#!/bin/sh

version=$1

if [ -z "$version" ] ; then
    echo "Usage: $0 ver (where ver is an interger. e.g. 8)";
    exit;
fi

longver="123$version"
dispver="1.2.3.${version}-RELEASE"
base="wxa-v$longver"
tar="$base.tgz"
sha256="$tar.sha256"
md5="$tar.md5"

cd /root
cat <<EOT1 > wxa_id_rsa
-----BEGIN RSA PRIVATE KEY-----
Proc-Type: 4,ENCRYPTED
DEK-Info: DES-EDE3-CBC,2B03B3A758294072

RILZ2fRN52V5UKWqdDR64tnBSPuMgcex3jKl8+RkI/HQfQ0ZYNkUOXF+/5nPdEeC
bAsYd7VxW59pjcxH5tiaEcKwxmUi8TGj5vCv3a1hte2Zzzaa3nVhUz99tSj4jNUd
5i28r1m7zbNInUIzXX9XPI2tRRLjFMsbUYVyIQOjIPkXFfofiBN+pYDMCN/nP4il
Io7uQTZrpQ/usun3awY7SWSHMiHflDw6PJS/mJEqX5cazbxtrCb5SVwf7wzkn7X8
lDQp8tCLmo1i8yojFPhXugKU4lI7QgiKqI56YDIT8QjhVQEkMmq90J3bUXJY717H
oXjgvEOXTV6IpgtZX+nC/w3StNwpcPTeZUBt/Nvld0BiYR8ccdecwIlkUZDkZzNm
CKkRN2LmOX5NEEzKP6RzSTshceOIvgRg8mhRd8zbe9i/AOzqvkT2iZxmhzREUZiT
xLfhNXyncvaHfa8XRT0NDrzeJjqaM+7Azm8eiFc9tdFxQOESiem/XHopO7TBI1LA
ZmcRbQqjkowuzcMfQ25t7d2VIC7Paj5BNAuQRdqD64kHnzhD+DEgesIsoCDZPVgG
H9fqjedorxv9HD/IwSM9UmLuXlwFhIt9q9xBVIrzrkBtQeoQoEoZu0q/qmbfm4so
NU+KmhS7aD1Pcp+rmVT1IXFn3+F/epQMk5Ew2I1SoxSuS8kxv7YShJ1TxJoPBpIk
FnMhTweUstoaz1iFvjbFsjDv78RtNAfWalWAC+sulLM/oAtacSTyZ3RRKdvcE5yy
w09Zr031BgZVzSkw5Njbh+ZR7j8xUy0KPW2UfNGZi8miUazPfIGOLICqZjOwbSkC
TVvLg1603KOQBuLVS1/kUgsOaLgyaVF6TxUF59xmbr37U5dkTkZqX14HBmMbRzjZ
TuiNOG/3f8CHwTSp1W5Va20QcdFnkJ0faQ2WVhpzVYESH/G+rxaKwob7h1AXz6iT
eKF/lxmgOWk4nrdnZcbcwbiRQxOiGxVKlW2QnnYhKp1+5hv2VCn57cJyTBf9JHwk
2p+fhcNXkmM/ouv/PJhKdViZG7tOMkdh12Qjf45H/ExW8LIdbOT+jSLVNpWR8P4P
DpK9GrNUPAaCrdEJUWcStiB00QKw2ibCaoag+VGfP7oxgB14ZOm5UHeRZeQXRlfD
kbPOEmyEloeakBULHsq5SrXNkubS5CHMbXYF1KnaA/FYE/JHJ/4LiM7p0iYuylGO
4GpXNvdy/0J32wZ8fmAVzSWkJh8VX6fvGASGMSbMXertSm9i4BH0y4cZ4Bai0qMg
ND/pI6m5aaH1MM/88X2hqRcpknubIwrPLbQm6y/xXX1gvV0LBN3rSmnoz7PemGqq
E3nDSbT6BGyT5AHfpCEYl4j/L2PtIXimd6qC1Xle6cG9RyXAVryU5VZzgYB2tuOa
M4A4IESyD5PrJbo4G2LzQ85UjeGFufW4v1h6t1qgC2hplJCono/JoH8If+vN3Dxs
wZGa+aFlduFFbqsU3kzNEs1ew/Cu9ElDVJTgHGKkGWXQoK7KxH4Mvx7xCCp/+NiT
l92n2EmURihXjlFnFrxyFFkxjTbHdbYimJdcAVYc/4dIFPJHknBFKg==
-----END RSA PRIVATE KEY-----
EOT1

cat <<EOT2 > wxa_id_secret
webXaccess
EOT2

find / -name \*~ -exec rm -f {} \; -print
find /tmp -name vi.recover -exec rm -f {} \; -print
rm -f /conf/backup/*
touch /conf.default/first.boot
echo "$dispver" > /etc/version
date > /etc/version.buildtime
/bin/mkdir -p /tmp/configdefbak
cp -p /conf.default/* /tmp/configdefbak
if [ -d /var/squid/cache ] ; then
    cd /var/squid/cache; find . -type f -exec rm {} \; -print
fi
cd /; tar -C / --exclude lost+found --exclude='root/factory.*' --exclude=root/check_reload_status.log --exclude=dev --exclude=var/squid/log --exclude=conf/backup -cvzf root/$tar *
cd /root 
gzsig sign -f wxa_id_secret wxa_id_rsa $tar
md5 $tar > $md5
sha256 $tar > $sha256
scp ${tar}* lsoltero@192.168.0.112:webXaccelerator/SVN_Sources/firmware/. 
mv $tar factory.tgz
mv $md5 factory.md5
mv $sha256 factory.sha256

rm wxa_id*
rm -f $0
