#!/usr/bin/perl

use XML::Parser;
use File::Basename;
my $path=dirname($0);
require "$path/tracking.pm";

$ENV{'PATH'} = "${path}:$ENV{'PATH'}";

use strict;

my $pinghost = "66.165.183.84";  # gsattrack.com

sub do_log_it(@)
{
    my @args = @_;
    @args = split(/\n/, $args[0]);
    my $i;
    for ($i = 0; $i < @args; $i++ ) {
	do_log("$args[$i]");
    }
}

sub do_bringup_iop_connection()
{
     my $count = 15;
     do_log("Brining up IOP Connection");
     my $stat;
     do {
          $stat = system("ping -q -c 1 -t 5 $pinghost >/dev/null");
#print "."
     } while ( $count-- && $stat );
     if ( $count < 0 && $stat ) {
	do_log("Unable to connect to the internet");
	return 0;
     }
     do_log("Connected");
     return 1;
}

sub do_gsattrack($)
{
    my ($what) = @_;
    my $args = "";
#    my $args = "--terminal=8.22.179.224";
    if ( $what eq "iop" ) {
	my ($iop) = `iop.pl`;
	chomp($iop);
	return if (!defined($iop) || $iop eq "" );
	my ($imei,$utime,$lat,$lon) = split(/,/, $iop);
	$args = "--utc=$utime --imei=$imei --lat=$lat --lon=$lon";
	return if ( !do_bringup_iop_connection() );
    }

    my $cmd = "sh -c '(gsattrack $args 2>&1)'";
    do_log($cmd);
    my @output = `$cmd`;
    @output = grep(/Serial|Trying|Eerror|Connect|Transmit|Parsed/, @output);
    do_log_it("@output") if ( @output );
}

$ENV{'PATH'}="/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/gmnbin";

my $parser = XML::Parser->new( Style => 'ETree' );
my $tree = $parser->parsefile("/conf/config.xml");

my $GSATFBB     = defined($$tree{'pfsense'}{'tracking'}{'gsatfbb'}) ? "on" : "off";
my $GSATIOP     = defined($$tree{'pfsense'}{'tracking'}{'gsatiop'}) ? "on" : "off";
my $MININTERVAL = $$tree{'pfsense'}{'tracking'}{'interval'};
my $SECINTERVAL= $MININTERVAL * 60;


do_open_log("Tracking");
do_log("Staring");
if ( $GSATIOP eq "off" && $GSATFBB eq "off" ) {
    do_exit("No devices enabled exiting");
}

if ( $MININTERVAL == 0 ) {
    do_exit("Tracking interval is 0. Exiting");
}

do_log("Tracking interval = $SECINTERVAL");
while (1) {
   if ( $GSATFBB eq "on" ) {
	do_log("GSatTrackFBB Wakeup");
	do_gsattrack("fbb");
   }
   if ( $GSATIOP eq "on" ) {
	do_log("GSatTrackIOP Wakeup");
	do_gsattrack("iop");
   }

   do_log("Sleeping for $SECINTERVAL");
   sleep ($SECINTERVAL);
}
