<?php
/* $Id$ */
/*
	services_dyndns.php
	part of m0n0wall (http://m0n0.ch/wall)

	Copyright (C) 2003-2004 Manuel Kasper <mk@neon1.net>.
	All rights reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.

	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

require("guiconfig.inc");

$pconfig['interval'] = $config['tracking']['interval'];
$pconfig['gsatfbb']  = isset($config['tracking']['gsatfbb']);
$pconfig['gsatiop']  = isset($config['tracking']['gsatiop']);

if ( !isset($pconfig['interval']) ) {
	$pconfig['interval'] = "60";
}

if ($_POST) {

	unset($input_errors);
	$pconfig = $_POST;
	
	/* input validation */
	if ( !is_numeric($_POST['interval']) ) {
		$input_errors[] = "Interval must be an interger larger than 1";
	} else {
		$pconfig['interval'] = $_POST['interval'] = (int)$_POST['interval'];
	}

	if (!$input_errors) {
		$config['tracking']['interval'] = $_POST['interval'];
		$config['tracking']['gsatfbb']  = ($_POST['gsatfbb']) ? true : false;
		$config['tracking']['gsatiop']  = ($_POST['gsatiop']) ? true : false;
		write_config();
		$savemsg = get_std_save_message(true);

		$startstop = (($_POST['gsatfbb']) || ($_POST['gsatiop'])) ? "start" : "stop";
		mwexec_bg("/usr/local/etc/rc.d/tracking.sh restart");
	}
} else 

$pgtitle = "Services: GPS Tracking";
$closehead = flase;
include("head.inc");

?>

</head>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php include("fbegin.inc"); ?>
<p class="pgtitle"><?=$pgtitle?></p>
<?php if ($input_errors) print_input_errors($input_errors); ?>
<?php if ($savemsg) print_info_box($savemsg); ?>
            <form action="services_tracking.php" method="post" name="iform" id="iform">
              <table width="100%" border="0" cellpadding="6" cellspacing="0">
                <tr>
                  <td colspan="2" valign="top" class="optsect_t">
				  <table border="0" cellspacing="0" cellpadding="0" width="100%">
				  <tr><td class="optsect_s"><strong>General Tracking Parameters</strong></td>
				  </table></td>
                </tr>
                <tr>
                  <td width="22%" valign="top" class="vncellreq">Tracking Interval</td>
                  <td width="78%" class="vtable">
                    <input name="interval" type="text" class="formfld" id="interval" size="30" value="<?=htmlspecialchars($pconfig['interval']);?>">
		    <br>
		    <span class="vexpl">
			Specify the tracking interval in minutes
		    </span>
                  </td>
		</tr>
                <tr>
                  <td colspan="2" class="list" height="12">&nbsp;</td>
                </tr>
                <tr>
                  <td colspan="2" valign="top" class="optsect_t">
				  <table border="0" cellspacing="0" cellpadding="0" width="100%">
				  <tr><td class="optsect_s"><strong>Tracking powered by GSatTrack</strong></td>
				  </table></td>
                </tr>
		<tr>
		  <td colspan="2" valign="top" class="vncell"> 
			Please visit <a href="http://www.RedportGlobal.com/gsattrack">www.RedPortGlobal.com/gsattrack</a> for registration information
		  </td>
                <tr>
                  <td width="22%" valign="top" class="vncellreq">FleetBroadband</td>
                  <td width="78%" class="vtable">
                    <input name="gsatfbb" type="checkbox" id="gsatfbb" value="yes" <?php if ($pconfig['gsatfbb']) echo "checked"; ?>>
                    Enable a connected FleetBroadband</td>
		</tr>
                <tr>
                  <td width="22%" valign="top" class="vncellreq">OpenPort</td>
                  <td width="78%" class="vtable">
                    <input name="gsatiop" type="checkbox" id="gsatiop" value="yes" <?php if ($pconfig['gsatiop']) echo "checked"; ?>>
                    Enable a connected Iridium OpenPort</td>
		</tr>
                <tr>
                  <td width="22%" valign="top">&nbsp;</td>
                  <td width="78%">
                    <input name="Submit" type="submit" class="formbtn" value="Save">
                  </td>
                </tr>
              </table>
</form>
<script language="JavaScript">
<!--
enable_change(false);
//-->
</script>
<?php include("fend.inc"); ?>
</body>
</html>
