<?php
/* $Id$ */
/*
    system_default_route.php
    Copyright (C) 2010 Luis Soltero
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

    2. Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    oR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
    POSSIBILITY OF SUCH DAMAGE.
*/

## Load Essential Includes
require_once('guiconfig.inc');

## Load Functions Files
require_once('includes/functions.inc.php');


## Load AJAX, Initiate Class ###############################################
require_once('includes/sajax.class.php');

## Initiate Class and Set location of ajax file containing 
## the information that we need for this page. Also set functions
## that SAJAX will be using.
$oSajax = new sajax();
$oSajax->sajax_remote_uri = 'sajax/system_default_route.sajax.php';
$oSajax->sajax_request_type = 'POST';
$oSajax->sajax_export("get_iostats");
$oSajax->sajax_handle_client_request();
############################################################################

$interfaces = get_configured_interface_list();

#
# process post requests
if ( $_POST ) {
	unset($input_errors);
	foreach ($interfaces as $interface) {
		$if = convert_friendly_interface_to_real_interface_name($interface);
		$friendly = convert_friendly_interface_to_friendly_descr($interface);
		if ( isset($_POST[$if]) ) {
//			echo "<br> found {$if} - {$interface} - {$_POST[$if]} - {$config['system']['defaultinterface']}</br>\n";
			$config['system']['defaultinterface'] = $interface;
			write_config("Changed default interface to {$interface}");
			$gw = get_interface_gateway($if);
		 	$oldgw = get_default_route_gw();	
			mwexec("/sbin/route del default");
			$stat = mwexec("ping -t 7 -oqc 3 -i 0.5 {$gw} 2>1 ");
                        if ( $stat ) $input_errors[] = "Gateway for {$friendly} at IP address {$gw} is unreachable";
			if ( $input_errors) { 
				$gw = $oldgw;
			}
			mwexec("/sbin/route add default {$gw}");
			
		}
	}
}

$defaultif  = get_default_interface_real();

## Set Page Title and Include Header
$pgtitle = "Set Default Route/Interface";
include("head.inc");

?>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<script language="javascript">
var ajaxStarted = false;
</script>
<?php
include("fbegin.inc");
	if(!file_exists("/usr/local/www/themes/{$g['theme']}/no_big_logo"))
		echo "<center><img src=\"./themes/".$g['theme']."/images/logobig.jpg\"></center><br>";
?>
<p class="pgtitle"><?=$pgtitle?></p>
<?php if ($input_errors) print_input_errors($input_errors); ?>
<div id="niftyOutter">
<form action="system_default_route.php" method="post">
<table bgcolor="#990000" width="100%" border="0" cellspacing="0" cellpadding="0">
	<tbody>
		<tr>
			<td colspan="3" class="listtopic">Select default system interface</td>
		</tr>
		<?php
		foreach ($interfaces as $interface) {
			if ( interface_has_gateway($interface)) {
				$descif = strtoupper(convert_friendly_interface_to_friendly_descr($interface));
				$if = convert_friendly_interface_to_real_interface_name($interface);
				if ( $if == $defaultif ) $descif .= " - default";
				echo "<tr>\n";
                        	echo "<td width=\"5%\" class=\"vncellt\">\n";
                                echo "<input type=\"submit\" name=\"$if\" value=\"Select\" class=\"formbtns\">\n";
                        	echo "</td>\n";
			 	echo "<td width=\"25%\" class=\"vncellt\">$descif</td>\n";
				echo "<td width=\"65%\" class=\"listr\">\n";
				echo "<input style=\"border: 0px solid white;\" size=\"60\" name=\"$interface\" id=\"$interface\" value=\"";
			        echo htmlspecialchars(get_if_io_stats($if));
				echo "\" />\n"; 
				echo "</tr>\n";
			 }
		}
		?>
	</tbody>
</table>
</form>
</div>

<?php include("fend.inc"); ?>
	    
<script type="text/javascript">
	NiftyCheck();
	Rounded("div#nifty","top","#FFF","#EEEEEE","smooth");
</script>

</body>
</html>
