<?php
/* $Id$ */
/*
    system_ppp.php
    Copyright (C) 2010 Luis Soltero
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

    2. Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
    AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    oR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
    POSSIBILITY OF SUCH DAMAGE.
*/

## Load Essential Includes
require_once('guiconfig.inc');

## Load Functions Files
require_once('includes/functions.inc.php');


## Load AJAX, Initiate Class ###############################################
require_once('includes/sajax.class.php');

## Initiate Class and Set location of ajax file containing 
## the information that we need for this page. Also set functions
## that SAJAX will be using.
$oSajax = new sajax();
$oSajax->sajax_remote_uri = 'sajax/system_ppp.sajax.php';
$oSajax->sajax_request_type = 'POST';
$oSajax->sajax_export("get_pppstats");
$oSajax->sajax_handle_client_request();
############################################################################

$pconfig = &$config['dialup'];
$IPDIAL = "/usr/local/gmnbin/ipdial.pl";

# process post requests
if ( $_POST ) {
	unset($input_errors);
	if ( $_POST['number'] == "" ) { 
		$input_errors[] = "You must have a phone number. Update settings and hit\"Save\".";
	}			
	if ($_POST['idletimeout'] != "" && is_numeric($_POST['idletimeout'])  )
	        $_POST['idletimeout']  = (int)$_POST['idletimeout'];
	if ( $_POST['idletimeout'] < 0 || !is_numeric($_POST['idletimeout']) ) {
		$input_errors[] = "Invalid idle timeout \"{$_POST['idletimeout']}\". Leave blank or enter an integer number of seconds.";
	}
	if ( !isset($input_errors) ) {
		if ( $_POST['submit'] == "Save" ) {
			$config['dialup']['username'] = $_POST['username'];
		 	$config['dialup']['password'] = $_POST['password'];
			$config['dialup']['init'] = $_POST['init'];
			$config['dialup']['number'] = $_POST['number'];
			$config['dialup']['baud'] = $_POST['baud'];
			$config['dialup']['idletimeout'] = $_POST['idletimeout'];
			write_config("Saving ppp dialup parameters");
		}

		if ( $_POST['connect'] == "Connect" ) {
			unset($errors);
			$pppargs = "-d -n \"{$pconfig['number']}\" -b \"{$pconfig['baud']}\"";
			if ( $pconfig['username'] != "" ) $pppargs .= " -u \"{$pconfig['username']}\"";
			if ( $pconfig['password'] != "" ) $pppargs .= " -p \"{$pconfig['password']}\"";
			if ( $pconfig['init'] != "" ) $pppargs .= " -i \"{$pconfig['init']}\"";	
			$idletimeout = "0";
			if ( $pconfig['idletimeout'] ) $idletimeout = $pconfig['idletimeout'];
			$pppargs .= " -t {$idletimeout}";
			exec("{$IPDIAL} {$pppargs}", $errors, $status);
			if ( $status ) {
				$input_errors[] = "Dialup failed with error \"{$errors[0]}\".";
			}
		}
		if ( $_POST['connect'] == "Disconnect" ) {
		        unset($errors);
			exec("${IPDIAL} -h", $errors, $status);
			if ( $status ) {
				$input_errors[] = "Disconnect failed with error \"{$errors[0]}\".";
			}
		}
	}
}

$connectbuttonval = "Connect";
if ( mwexec("{$IPDIAL} -s") ) $connectbuttonval = "Disconnect";

$defaultif  = get_default_interface_real();

## Set Page Title and Include Header
$pgtitle = "PPP Dialup";
include("head.inc");

?>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<script language="javascript">
var ajaxStarted = false;
</script>
<?php
include("fbegin.inc");
	if(!file_exists("/usr/local/www/themes/{$g['theme']}/no_big_logo"))
		echo "<center><img src=\"./themes/".$g['theme']."/images/logobig.jpg\"></center><br>";
?>
<p class="pgtitle"><?=$pgtitle?></p>
<?php if ($input_errors) print_input_errors($input_errors); ?>
<div id="niftyOutter">
<form action="system_ppp.php" method="post">
<table width="100%" border="0" cellspacing="0" cellpadding="6">

                <tr>    
                        <td colspan="2" valign="top" class="listtopic">Manage Dialup PPP Connection</td>
                </tr>
                <tr>    
                        <td width="25%" class="vncellt"><input name="connect" type="submit" class="formbtn" id="pppbutton" value="<?= $connectbuttonval ?>"/>
                        <td width="75%" class="listr"><input style="border: 0px solid white;" size="60" name="pppstat" id="pppstat" value="
<?= htmlspecialchars("PPP Connection Status"); ?>" /></td>
                </tr>
                <tr>
                        <td colspan="2" class="list" height="12"></td>
                </tr>   

		<tr>
			<td colspan="3" class="listtopic">PPP Dialup Settings</td>
		</tr>
		<tr>
			<td width="25%" class="vncellt">ISP username</td>
			<td width="75%" class="vtable"><input name="username" type="text" class="formfld" id="username" size="40" value="<?= htmlspecialchars($pconfig['username']); ?>">
			<br> <span class="vexpl">Optional username only if required by ISP</span></td>
		</tr>
		<tr>
			<td width="25%" class="vncellt">ISP password</td>
			<td width="75%" class="vtable"><input name="password" type="text" class="formfld" id="password" size="40" value="<?= htmlspecialchars($pconfig['password']); ?>">
			<br> <span class="vexpl">Optional password only if required by ISP</span></td>
		</tr>
		<tr>
			<td width="25%" class="vncellt">Extra initialization</td>
			<td width="75%" class="vtable"><input name="init" type="text" class="formfld" id="init" size="40" value="<?= htmlspecialchars($pconfig['init']); ?>">
			<br> <span class="vexpl">e.g. <em>AT+CBST=71,0,1</em> for Iridium</span></td>
		</tr>
		<tr>
			<td width="25%" class="vncellt">Phone number</td>
			<td width="75%" class="vtable"><input name="number" type="text" class="formfld" id="number" size="40" value="<?= htmlspecialchars($pconfig['number']); ?>">
			<br> <span class="vexpl">e.g. <em>00881600025</em> for Iridium or <em>**94#</em> for INMARSAT MPDS</span>
			</td>
		</tr>
		<tr>
			<td width="25%" class="vncellt">Baud rate</td>
			<td width="75%" class="vtable"><select name="baud"> 
			<?php
			    $bauds = array(1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200);
			    foreach ($bauds as $baud ) {
				$selected = "";
				if ( $baud == $pconfig['baud'] ) { 
					$selected = "selected";
				}
				echo "<option value=\"$baud\" $selected>$baud</option>\n";
			    }
			?>
			</select>
                        <br> <span class="vexpl">e.g. <em>19200</em> for Iridium or <em>115200</em> for INMARSAT MPDS</span>
			</td>
		</tr>
               <tr>
                        <td width="25%" class="vncellt">Idle timeout</td>
                        <td width="75%" class="vtable"><input name="idletimeout" type="text" class="formfld" id="idletimeout" size="40" value="<?= htmlspecialchars($pconfig['idletimeout']); ?>">
                        <br> <span class="vexpl">Idle timeout in seconds. Enter <em>0</em> or leave blank to disable timeout</span>
                        </td>
                </tr>

                <tr>
                  <td width="22%" valign="top">&nbsp;</td>
                  <td width="78%"> <input name="submit" type="submit" class="formbtn" value="Save"></td>
		</tr>
</table>
</form>
</div>

<?php include("fend.inc"); ?>
	    
<script type="text/javascript">
	NiftyCheck();
	Rounded("div#nifty","top","#FFF","#EEEEEE","smooth");
</script>

</body>
</html>
