#!/bin/sh

counter=1
while [ "$counter" -ne 0 ]
do

# polling traffic for interface lan vr0 
/usr/local/bin/rrdtool update /var/db/rrd/lan-traffic.rrd N:\
`/usr/bin/netstat -nbf link -I vr0 | /usr/bin/awk '{getline 2;print $7 ":" $10}'`

# polling packets for interface lan vr0 
/usr/local/bin/rrdtool update /var/db/rrd/lan-packets.rrd N:\
`/usr/bin/netstat -nbf link -I vr0 | /usr/bin/awk '{getline 2;print $5 ":" $8}'`

# polling traffic for interface wan vr1 
/usr/local/bin/rrdtool update /var/db/rrd/wan-traffic.rrd N:\
`/usr/bin/netstat -nbf link -I vr1 | /usr/bin/awk '{getline 2;print $7 ":" $10}'`

# polling packets for interface wan vr1 
/usr/local/bin/rrdtool update /var/db/rrd/wan-packets.rrd N:\
`/usr/bin/netstat -nbf link -I vr1 | /usr/bin/awk '{getline 2;print $5 ":" $8}'`
get_quality_stats_wan () {
	packetloss_wan=100
	roundtrip_wan=0
	local out_wan
	out_wan=` ping -c 5 -q 192.168.0.1 `
	if [ $? -eq 0 ]; then
		packetloss_wan=` echo $out_wan | cut -f18 -d' ' | cut -c -1 `
		roundtrip_wan=` echo $out_wan | cut -f24 -d' ' | cut -f2 -d'/' `
	fi
	/usr/local/bin/rrdtool update /var/db/rrd/wan-quality.rrd N:$packetloss_wan:$roundtrip_wan
}

get_quality_stats_wan &


# polling traffic for interface ipsec enc0 
/usr/local/bin/rrdtool update /var/db/rrd/ipsec-traffic.rrd N:\
`/usr/bin/netstat -nbf link -I enc0 | /usr/bin/awk '{getline 2;print $6 ":" $9}'`

# polling packets for interface ipsec enc0 
/usr/local/bin/rrdtool update /var/db/rrd/ipsec-packets.rrd N:\
`/usr/bin/netstat -nbf link -I enc0 | /usr/bin/awk '{getline 2;print $4 ":" $7}'`

pfctl_si_out="` /sbin/pfctl -si > /tmp/pfctl_si_out `"
pfctl_ss_out="` /sbin/pfctl -ss > /tmp/pfctl_ss_out`"
pfrate="` cat /tmp/pfctl_si_out | egrep "inserts|removals" | awk '{ pfrate = $3 + pfrate } {print pfrate}'|tail -1 `"
pfstates="` cat /tmp/pfctl_ss_out | egrep -v "<\-.*?<\-|\->.*?\->" | wc -l|sed 's/ //g'`"
pfnat="` cat /tmp/pfctl_ss_out | egrep '<\-.*?<\-|\->.*?\->' | wc -l|sed 's/ //g' `"
srcip="` cat /tmp/pfctl_ss_out | egrep -v '<\-.*?<\-|\->.*?\->' | grep '\->' | awk '{print $3}' | awk -F: '{print $1}' | sort -u|wc -l|sed 's/ //g' `"
dstip="` cat /tmp/pfctl_ss_out | egrep -v '<\-.*?<\-|\->.*?\->' | grep '<\-' | awk '{print $3}' | awk -F: '{print $1}' | sort -u|wc -l|sed 's/ //g' `"
/usr/local/bin/rrdtool update /var/db/rrd/system-states.rrd N:$pfrate:$pfstates:$pfnat:$srcip:$dstip

`/usr/bin/top -d 2 -s 1 0 | /usr/bin/awk '{gsub(/%/, "")} BEGIN { \
printf "/usr/local/bin/rrdtool update /var/db/rrd/system-processor.rrd " } \
{ if ( $2 == "processes:" ) { processes = $1; } \
else if ( $1 == "CPU:" ) { user = $2; nice = $4; sys = $6; interrupt = $8; } \
} END { printf "N:"user":"nice":"sys":"interrupt":"processes }'`

sleep 60
done
